#include <stdio.h>
#include <stdlib.h>
#include "../outils-src/par_manycore.h"
typedef struct {int level;} Level;
typedef struct {int i; int l;} Arg;
int nv, vv, am;
void bfs_level(int k, int level);
int decimal_digit(int i, void *arg){
 return par_getchar_i(i)-'0';
}
int get_index(int i, void *arg){return i;}
int is_not_decimal_digit(int i, void *arg){
 char c=par_getchar_i(i); return (c<'0' || c>'9');
}
int eon(int i){
 return until_reduce(i,1,0x7ffffff,is_not_decimal_digit,NULL,
                                   get_index,NULL,reduce_min,NULL);
}
int number(int i, int n, int a, int b, void *arg){
 int p;
 if (n==1) return a; if (n==2) return a*10+b;
 p=par_power(10,n-n/2); return a*p+b;
}
int par_atoi(int i){
 return for_reduce(i,eon(i)-i,0,decimal_digit,NULL,number,NULL);
}
char v(int i){
 return par_getchar_i(vv+i);
}
int is_edge(int i, int j){
 return par_getchar_i(am+(i*(nv+1)+j))-'0';
}
void graph_init(){
 nv=par_atoi(0);
 vv=eon(0)+1;
 am=vv+nv+1;
}
void init_value(int k, int i, void *arg){
 int produced_value, j;
 if (i==0) produced_value=0;
 else produced_value=-1;
 send_int(k, produced_value);
 for (j=0;j<i;j++) send_int(k, receive_int(k));
}
void stop(int k, int i, int size, void *arg){
 int consumed_value=receive_int(k), j;
 for (j=1;j<size-i;j++){
  send_int(k, consumed_value);
  consumed_value=receive_int(k);
 }
}
void put_visited_vertex_and_set_level(int k, int i, int size, void *arg){
 Arg *a=(Arg *)arg;
 int cv=receive_int(k), pv, j;
 for (j=1;j<size-i;j++){
  send_int(k, cv);
  cv=receive_int(k);
 }
 if (is_edge(a->i,i) && (cv==-1)){
  par_putchar_next(v(i));
  pv=a->l;
 }
 else pv=cv;
 send_int(k, pv);
 for (j=0;j<i;j++) send_int(k, receive_int(k));
}
void adjacent(int k, int i, void *arg){
 Level *l=(Level *)arg; Arg a; a.i=i; a.l=l->level;
 for_loop_update_int(k,0,nv,nv,put_visited_vertex_and_set_level,
                      (void *)&a,update_int);
}
void current_level(int k, int i, int size, void *arg){
 Level *l=(Level *)arg;
 int cv=receive_int(k), pv, j;
 for (j=1;j<size-i;j++){
  send_int(k, cv);
  cv=receive_int(k);
 }
 send_int(k, cv);
 for (j=0;j<i;j++) send_int(k, receive_int(k));
 if (cv==l->level-1) adjacent(k, i,arg);
}
void next_level(int k, int i, int size, void *arg){
 Level *l=(Level *)arg;
 int cv=receive_int(k), pv, j;
 for (j=1;j<size-i;j++){
  send_int(k, cv);
  cv=receive_int(k);
 }
 send_int(k, cv);
 for (j=0;j<i;j++) send_int(k, receive_int(k));
 if (cv==l->level) bfs_level(k,l->level);
}
void bfs_level(int k, int level){
 Level l; l.level=level+1;
 if (l.level==nv){
  for_loop_consume_int(k,0,nv,nv,stop,NULL,consume_int);
  return;
 }
 for_loop_update_int(k,0,nv,nv,current_level,&l,update_int);
 for_loop_update_int(k,0,nv,nv,next_level,&l,update_int);
}
void main(){
 graph_init();
 for_loop_produce_int(1,0,nv,init_value,NULL,produce_int);
 par_putchar_next(v(0)); bfs_level(1,0);
 par_putchar_next('\n');
}
